package com.example.ftpdemo;

import cn.hutool.core.date.DateUtil;
import com.example.ftpdemo.cache.CodeCache;
import com.example.ftpdemo.entity.NbmsEnprefix;
import com.example.ftpdemo.entity.NbmsEntApply;
import com.example.ftpdemo.service.NbmsEnprefixService;
import com.example.ftpdemo.service.NbmsEntApplyServcie;
import com.example.ftpdemo.util.Decrypt;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.List;

@SpringBootTest
class FtpDemoApplicationTests {


    String companyCode;  //标识码企业前缀
    String companyName; // 标识解析节点经营主体名称
    String level; // 标识解析系统级别
    String accessProvince; // 接入省份
    String accessCity; //  接入地市
    String registerTime; // 注册时间
    String categoryA; // 经营主体行业门类
    String categoryB; //  经营主体行业大类
    String companyType; //  公司性质
    String serviceProfession; //节点服务行业
    String startIP = "223.99.228.240";
    String endIP = "223.99.228.240";
    String position = "中国山东省济南市自由贸易试验区济南片区颖秀路2299号";
    @Autowired
    private NbmsEntApplyServcie servcie;
    @Autowired
    private NbmsEnprefixService enprefixService;


    @Test
    void contextLoads() throws IOException {
        // 生成文件

        List<NbmsEntApply> list = servcie.lambdaQuery().eq(NbmsEntApply::getFirstAuditStatus, 2)
                .eq(NbmsEntApply::getApplyType, 1)
                .list();
        // 创建输出流
        FileOutputStream stream = new FileOutputStream("d://aaa//test.txt");
        for (NbmsEntApply nbmsEnapply : list) {
            companyCode = nbmsEnapply.getEntPrefix();
            companyName = nbmsEnapply.getOrgName();
            level = "4";
            accessProvince = nbmsEnapply.getOrgAddrProvince();
            accessProvince = CodeCache.codeMap.get(accessProvince);

            accessCity = nbmsEnapply.getOrgAddrCity();
            accessCity = CodeCache.codeMap.get(accessCity);

            registerTime = DateUtil.format(nbmsEnapply.getUpdateDate(), "yyyy-MM-dd HH:mm:ss");

            categoryA = nbmsEnapply.getIndustrySpecific();
            categoryA = CodeCache.codeMap.get(categoryA);

            categoryB = nbmsEnapply.getIndustryCategory();
            categoryB = CodeCache.codeMap.get(categoryB);

            companyType = judge(nbmsEnapply.getOrgNature());
            serviceProfession = categoryB;

            String template = companyCode + "|" + companyName + "|" + level + "|" + accessProvince + "|" + accessCity + "|" + registerTime + "|" + categoryA + "|" + categoryB + "|" + companyType + "|" + serviceProfession + "\n";
            byte[] bytes = template.getBytes();
            stream.write(bytes);
        }
        stream.flush();
        stream.close();
        System.out.println("完成！！！");
    }

    @Test
    void test1() throws IOException {
        List<NbmsEnprefix> list = enprefixService.query()
                .select("DISTINCT(ent_name)")
                .eq("proxy_state", 4)
                .list();
        // 创建输出流
        FileOutputStream stream = new FileOutputStream("D://aaa//test.txt");
        for (NbmsEnprefix enprefix : list) {
            companyName = enprefix.getEntName();
            String template = companyName + "|" + startIP + "|" + endIP + "|" + position + "\n";
            byte[] bytes = template.getBytes();
            stream.write(bytes);
        }
        stream.flush();
        stream.close();
    }

    @Test
    void five() throws IOException {
        // 生成文件

        List<NbmsEntApply> list = servcie.lambdaQuery().eq(NbmsEntApply::getFirstAuditStatus, 2)
                .eq(NbmsEntApply::getApplyStep, 4)
                .eq(NbmsEntApply::getApplyType, 1)
                .list();
        // 创建输出流
        FileOutputStream stream = new FileOutputStream("d://aaa//test.txt");
        for (NbmsEntApply nbmsEnapply : list) {
            companyCode = nbmsEnapply.getEntPrefix();
            companyName = nbmsEnapply.getOrgName();
//            level = "4";
            accessProvince = nbmsEnapply.getOrgAddrProvince();
            accessProvince = CodeCache.codeMap.get(accessProvince);

            accessCity = nbmsEnapply.getOrgAddrCity();
            accessCity = CodeCache.codeMap.get(accessCity);

            registerTime = DateUtil.format(nbmsEnapply.getUpdateDate(), "yyyy-MM-dd HH:mm:ss");

            categoryA = nbmsEnapply.getIndustrySpecific();
            categoryA = CodeCache.codeMap.get(categoryA);

            categoryB = nbmsEnapply.getIndustryCategory();
            categoryB = CodeCache.codeMap.get(categoryB);

            companyType = judge(nbmsEnapply.getOrgNature());
            serviceProfession = categoryB;

            String template = companyCode + "|" + companyName + "|" + accessProvince + "|" + accessCity + "|" + registerTime + "|" + categoryA + "|" + categoryB + "|" + companyType + "|" + serviceProfession + "\n";
            byte[] bytes = template.getBytes();
            stream.write(bytes);
        }
        stream.flush();
        stream.close();
        System.out.println("完成！！！");
    }

    @Test
    void test33(){
        Decrypt.readFileByLines("C:\\Users\\Reborn\\Desktop\\fsdownload\\88.100_2022-11-10_7301f27a6a92497c86d19ba578e81c83_c1cd57d4f4406a28773e664170073d25.gz");
//        List<File> allFile = Decrypt.getAllFile("C:\\Users\\Reborn\\Desktop\\fsdownload");
//        for (File file : allFile) {
//            System.out.println(file);
//        }
    }


    @Test
    void deleTest(){
        File file = new File("D:\\aaa\\SDQN-basic_registered-1669779364902-all.bin");
        System.out.println(file);
        boolean delete = file.delete();
        System.out.println(delete);

    }

    private String judge(int companyType) {
        //单位性质，国有控股、民营控股、外商控股、事业单位、民营非盈利
        if (companyType == 1) {
            return "国有控股";
        }
        if (companyType == 2) {
            return "民营控股";
        }
        if (companyType == 3) {
            return "外商控股";
        }
        if (companyType == 4) {
            return "事业单位";
        }
        if (companyType == 5) {
            return "民营非盈利";
        }

        return null;
    }


}
